/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * nsIHttpServer.idl
 */

package org.mozilla.interfaces;

public interface nsIHttpRequestMetadata extends nsIPropertyBag {

  String NS_IHTTPREQUESTMETADATA_IID =
    "{3a899b17-b6eb-4333-8ef4-912df454a551}";

  /**
 * A representation of the data included in an HTTP request.
 */
/**
   * The request type for this request (see RFC 2616, section 5.1.1).
   */
  String getMethod();

  /**
   * The host of the data being requested (e.g. "localhost" for the
   * http://localhost:8080/file resource).  Note that the relevant port on the
   * host is specified in this.port.
   */
  String getHost();

  /**
   * The port on the server on which the request was received.
   */
  long getPort();

  /**
   * The requested path, without any query string (e.g. "/dir/file.txt").  It is
   * guaranteed to begin with a "/".  This string is in the 
   */
  String getPath();

  /**
   * The URL-encoded query string associated with this request, not including
   * the initial "?".
   */
  String getQueryString();

  /**
   * A string containing the HTTP version of the request (i.e., "1.1").  Leading
   * zeros for either component of the version will be omitted.  (In other
   * words, if the request contains the version "1.01", this attribute will be
   * "1.1"; see RFC 2616, section 3.1.)
   */
  String getHttpVersion();

  /**
   * Returns the value for the header in this request specified by fieldName.
   *
   * @param fieldName
   *   the name of the field whose value is to be gotten; note that since HTTP
   *   header field names are case-insensitive, this method produces equivalent
   *   results for "HeAdER" and "hEADer" as fieldName
   * @returns
   *   the field value for the given header; note that this value may be
   *   normalized (e.g., leading/trailing whitespace removed from the value [or
   *   from the values which make this up, if the header is a comma-separated
   *   list of values], whitespace runs compressed to single spaces, etc.)
   * @throws NS_ERROR_INVALID_ARG
   *   if fieldName does not constitute a valid header field name
   * @throws NS_ERROR_NOT_AVAILABLE
   *   if the given header does not exist in this
   */
  String getHeader(String fieldName);

  /**
   * Returns true if a header with the given field name exists in this, false
   * otherwise.
   *
   * @param fieldName
   *   the field name whose existence is to be determined in this; note that
   *   since HTTP header field names are case-insensitive, this method produces
   *   equivalent results for "HeAdER" and "hEADer" as fieldName
   * @throws NS_ERROR_INVALID_ARG
   *   if fieldName does not constitute a valid header field name
   */
  boolean hasHeader(String fieldName);

  /**
   * An nsISimpleEnumerator of nsISupportsStrings over the names of the headers
   * in this request.  The header field names in the enumerator may not
   * necessarily have the same case as they do in the request itself.
   */
  nsISimpleEnumerator getHeaders();

}